#ifndef CHASH_H
#define CHASH_H

#include <features.h>
__BEGIN_DECLS

#include "clist.h"

#define CHASH_FUNC(x) int (*x)(void *a, int size)
#define CDISPLAY_FUNC(x) void (*x)(void *data)


typedef struct {
	clist **vector;
	int size;
	CHASH_FUNC(hash_func);
	CITEM_FREE(free_func);
} chash;


/* function definitions */

chash *chash_init(chash *htable, int size, CHASH_FUNC(hash_func),
		CITEM_FREE(free_func));
clist *chash_insert(chash *htable, void *data);
clist *chash_insert_sorted(chash *htable, void *data, CCOMPARE_FUNC(ccfunc));
clist *chash_remove(chash *htable, void *data);
clist *chash_remove_custom(chash *htable, void *user_data, CCOMPARE_FUNC(ccfunc));
void chash_free(chash *htable);
void chash_free_with_data(chash *htable);
clist *chash_find(chash *htable, void *data);
clist *chash_find_custom(chash *htable, void *user_data, CCOMPARE_FUNC(ccfunc));
clist *chash_find_min_head(chash *htable, CCOMPARE_FUNC(ccfunc));

/* Interface for linear access to the hash table */

clist *chash_nth(chash *htable, int n);
void *chash_nth_data(chash *htable, int n);
void chash_foreach(chash *htable, CITEM_FUNC(cifunc), void *user_data);
int chash_length(chash *htable);

__END_DECLS

#endif /* CHASH_H */
