#ifndef CTIMER_H
#define CTIMER_H

#include <features.h>
__BEGIN_DECLS

#include <time.h>
#include "clist.h" 

#define CTIMER_FUNC(x) void x(void *data)
#define CTIMER_FUNC_PTR(x) void (*x)(void *data)

typedef struct {
	int id;
	int delay;		/* delay in seconds for each call */
	int repeat;		/* no. of times to repeat */
	time_t last_called;	/* time of last call */
	void *user_data;	/* arbitrary (malloc'ed) arg to tfunc */
	CTIMER_FUNC_PTR(tfunc);	/* function to call for timer */
} ctimerinf_t;


/* function definitions */

int ctimer_add(int delay, int repeat, CTIMER_FUNC_PTR(tfunc), void *user_data);
int ctimer_remove(int timer_id);
void ctimer_remove_all();
int ctimer_run();
int ctimer_reset(int timer_id, int delay, int repeat,
		CTIMER_FUNC_PTR(tfunc),void *user_data);

__END_DECLS

#endif /* CTIMER_H */
