#ifndef DEFS_H
#define DEFS_H

#include <features.h>
__BEGIN_DECLS

#include "clist.h"

#define TRUE 1
#define FALSE 0

/* Define to make the daemon print error messages to stdout */
#define DEBUG

/* The port on which to listen for other daemons/task messages */
#define DPORT 8888

/* Maximum length of a file's path plus one */
#define MAX_PATH_BUFFER 1024

/* Maximum length of line in config files including NULL */
#define MAX_LINE_SIZE 512

/* Maximum length of a hostname */
#define MAX_HOSTNAME_SIZE 512

/* Default time to live of a connection if not specified in config */
#define DEFAULT_CONN_TTL 60

/* Timeout for VAS registry msg */
#define VAS_REGISTER_TIMEOUT 60

/* Timeout for all transactions */
#define TRANS_TIMEOUT 60

/* Interval for polling collective terminate */
#define TASKPOLL_INTERVAL 10

/* Interval for syncing task list */
#define SYNC_TASKLIST_INTERVAL 10

/* Path for downloading and running binaries from */
#define DEFAULT_BINARY_DIR "/tmp"

/* Size of MD5 digest in bytes */
#define MD5_DIGEST_SIZE 16

/* Maximum size of all argv arguments to master task */
#define MAX_ARGV_SIZE 2048

/* A zero length string */
#define empty_string ""

/* Define to empty if the keyword does not work.  */
#undef const

/* Define to `unsigned' if <sys/types.h> doesn't define.  */
#undef size_t

/* Define if you have the ANSI C header files.  */
#undef STDC_HEADERS

/* Define if your processor stores words with the most significant
   byte first (like Motorola and SPARC, unlike Intel and VAX).  */
#undef WORDS_BIGENDIAN

/* Define to `signed' if <sys/types.h> doesn't define.  */
#undef ssize_t

/* Define if you have the <endian.h> header file.  */
#undef HAVE_ENDIAN_H

/* Define if you have the <limits.h> header file.  */
#undef HAVE_LIMITS_H

__END_DECLS

#endif /* DEFS_H */
