#ifndef IO_H
#define IO_H

#include <features.h>
__BEGIN_DECLS

#include "msgs.h"

/* Supported types of fd. The AUTH type is present if
 * bit 7 of the type is set. */
#define FDTYPE_NONE		0
#define FDTYPE_MSG		1
#define FDTYPE_LOCALMSG		2
#define FDTYPE_LOCALDATA	4
#define FDTYPE_LISTEN		8
#define FDTYPE_AUTH		128
#define FDTYPE_NOAUTH		0

#define FDTYPE(fd) ((char)(io_type[fd] & ~(FDTYPE_AUTH)))
#define FDAUTH(fd) ((char)(io_type[fd] & (FDTYPE_AUTH)))

void init_io();
int msg_read(int fd);
int msg_fd_write(msghdr_t *msg, void *data, int fd);
int msg_write(msghdr_t *msg, void *data);
int msg_reply(msghdr_t *msg, void *data, int fd);

/* The following are only availble to the daemon*/
#ifdef NCDAEMON
int msg_lread(int fd);
int msg_lwrite(msghdr_t *msg, void *data, task_id *tid);
#endif /* NCDAEMON */

int fd_authorize(int fd);
int fd_unauthorize(int fd);
int fd_set_type(int fd, int type);
int fd_open(int fd, int type);
int fd_close(int fd);
int fd_close_all();
int fd_open_write(int fd, int type);
int fd_close_write(int fd);

extern char *io_type;
extern int fd_has_closed;

__END_DECLS

#endif /* IO_H */
