#ifndef LOG_H
#define LOG_H

#include <features.h>
__BEGIN_DECLS

#include <syslog.h>
#include <stdio.h>

#include "defs.h"

/* Types of messages to log by default */
#ifdef DEBUG
#define DEFAULT_LOGGING (LOG_EMERG|LOG_ALERT|LOG_CRIT|LOG_ERR|LOG_WARNING|LOG_NOTICE|LOG_INFO|LOG_DEBUG)
#else
#define DEFAULT_LOGGING (LOG_EMERG|LOG_ALERT|LOG_CRIT|LOG_ERR|LOG_WARNING)
#endif

/* Max size of message text in bytes */
#define MAX_LOG_SIZE 1024

#if 0
/* Types of log messages - defined in syslog.h  */
#define LOG_EMERG	1	/* system is unusable               */
#define LOG_ALERT	2	/* action must be taken immediately */
#define LOG_CRIT	4	/* critical conditions              */
#define LOG_ERR		8	/* error conditions                 */
#define LOG_WARNING	16	/* warning conditions               */
#define LOG_NOTICE	32	/* normal but significant condition */
#define LOG_INFO	64	/* informational                    */
#define LOG_DEBUG	128	/* debug message                    */
#endif

int set_log_types(int type);
int set_log_type(int type);
int clear_log_type(int type);
int get_log_types();
int set_module_name(char *mname);
int set_log_file(char *fname);

void do_log_orig(int type, char *fmt, ...);
extern void (*do_log)(int type, char *fmt, ...);
void yell_orig(char *fmt, ...);
extern void (*yell)(char *fmt, ...);

extern char log_buffer[];

extern FILE *log_file;

__END_DECLS

#endif /* LOG_H */
