#ifndef TRANSACT_H
#define TRANSACT_H

#include <features.h>
__BEGIN_DECLS

#include "ctimer.h"

#define TRANSFAIL_HANDLER(x) void x(transact_t *trans, void *data)
#define TRANSFAIL_HANDLER_PTR(x) void (*x)(transact_t *trans, void *data)


/* Function definitions */
int trans_remove(u_int16_t trans_id);
int trans_remove_all();
int trans_write(msghdr_t *msghdr, void *msgdata,
		TRANSFAIL_HANDLER_PTR(hnd_fail),
		void *faildata, int timeout);
int trans_reply(msghdr_t *msghdr, void *msgdata, int fd);
transact_t *trans_get(u_int16_t trans_id);
CTIMER_FUNC(trans_run);

#ifdef NCDAEMON
#define trans_lreply trans_reply
int trans_lwrite(msghdr_t *msghdr, void *msgdata, task_id *tid,
		TRANSFAIL_HANDLER_PTR(hnd_fail),
		void *faildata, int timeout);
#endif /* NCDAEMON */

__END_DECLS

#endif /* TRANSACT_H */
