#ifndef UTIL_H
#define UTIL_H

#include <features.h>
__BEGIN_DECLS

#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>


#include "defs.h"
#include "msghnd.h"

#define DIR_SEPARATOR '/'
#define MAX_STRADDR_SIZE 32


int make_daemon_id(daemon_id *id, char *ip, int port);
int make_self_daemon_id(daemon_id *id, int port);
int make_task_id(task_id *tid, daemon_id *did, int pid);
int sockaddr_to_naddr(struct sockaddr_in *sa, naddr_t *na);
int str_to_naddr(char *str, naddr_t *na);
char *naddr_to_str(naddr_t *na);

int ntoh_msg(msghdr_t *msg);
int hton_msg(msghdr_t *msg);
int ntoh_taskreq(taskreq_t *tr);
int hton_taskreq(taskreq_t *tr);
int ntoh_taskarg(taskarg_t *tr);
int hton_taskarg(taskarg_t *tr);
int ntoh_taskrply(taskrply_t *tr);
int hton_taskrply(taskrply_t *tr);
int ntoh_vasreg_rply(vasreg_rply_t *tr);
int hton_vasreg_rply(vasreg_rply_t *tr);
int ntoh_vasload(vasload_t *tr);
int hton_vasload(vasload_t *tr);
int ntoh_ftpid(ftpid_t *tr);
int hton_ftpid(ftpid_t *tr);
int ntoh_ftpinit(ftpinit_t *tr);
int hton_ftpinit(ftpinit_t *tr);
int ntoh_rpcinfo(rpcinfo_t *tr);
int hton_rpcinfo(rpcinfo_t *tr);
int ntoh_rpcaccept(rpcaccept_t *tr);
int hton_rpcaccept(rpcaccept_t *tr);
int ntoh_exitinfo(exitinfo_t *tr);
int hton_exitinfo(exitinfo_t *tr);
int ntoh_taskpoll(taskpoll_t *tr);
int hton_taskpoll(taskpoll_t *tr);

char *malloc_strcpy(char *str);
char *malloc_strcat(char *str1, char *str2);
char *strmcpy(char *dest, char *src, int n);
char *strmcat(char *dest, char *src, int n);
char *trim_leading_spaces(char *str);
char *trim_trailing_spaces(char *str);
char *trim_spaces(char *str);
int str_isempty(char *str);
int str_isinteger(char *str);
int str_isfloat(char *str);
int str_ischarset(char *str, char *charset);
char *sindex(char *str, char *cset);
char *rsindex(char *str, char *cset);
char *next_arg(char *str, char **new_str);
char *next_arg_custom(char *str, char **new_str, char *sep);
char *last_arg(char *str, char **new_str);
int word_count(char *str);
char *base_name(char *path);
char *get_homedir();
char *expand_tilde(char *tstr);
int put_param(char *buf, size_t n, char *fmt, va_list ap);
int get_param(char *buf, char *fmt, va_list ap);
int get_sparam(char *buf, char *fmt_skip, char *fmt, va_list ap);
int put_argv(char *buf, size_t n, int argc, char *argv[]);
char **get_argv(char *buf, int argc, int blank);
char *free_argv(int argc, char **argv);

__END_DECLS

#endif /* UTIL_H */
