#ifndef VAS_H
#define VAS_H

#include <features.h>
__BEGIN_DECLS

#include "structs.h"

/* * * * * * * * * * * * * * * * * * * * * * * * *
 *	               VAS			 *
 *	   Voluntary Address Server	      	 *
 *			      			 *
 * This will be maintaining the daemon ids and   *
 * the loads of the daemons that have registered *
 * to participate in the distributing system     * 
 * chashtable is used for storing them           *
 * * * * * * * * * * * * * * * * * * * * * * * * */

/* Size of VAS hashing table */
#define VAS_HASHTABLE_SIZE 97

/* Ping interval in seconds for polling connected clients */
#define VAS_PING_INTERVAL 30
#define VAS_PING_TIMEOUT_INTERVAL 5


typedef struct {
	daemon_id dem_id;
	vasload_t load;
} vasclient_t;


/* function definitions */
int ncvas_item_cmp(void *a, void *b);
int ncvas_itemload_cmp(void *a, void *b);
void ncvas_item_display(void *vclient, void *dummy);

__END_DECLS

#endif /* VAS_H */
