/*
 * wcon v0.5 GUI library for the console
 * Written by Fakhir Ansari <ansari89@yahoo.com>
 *
 * The container class
 *
 */
#ifndef CONTAIN_H
#define CONTAIN_H


/* A general container class (linked list) */
class CContainer {
public:
    CContainer();
    CContainer(int );

    void Initialize(int);

    bool AddTop(void *);
    bool AddBottom(void *);
    bool InsertItem(int,void *);

    void *GetTop();
    void *GetBottom();
    void *GetItem(int );

    bool RemoveTop();
    bool RemoveBottom();

    bool Reset();
    void *GetCurrent();
    bool MoveNext();
    bool MovePrev();

    int GetTotal();
    int IsEmpty();

    bool Delete(int);
    bool DeleteAll();

private:
    /* Node class */
    class CItem {
    public:
	CItem();

	char *Buffer;
	CItem *Next;
	CItem *Prev;
    } *Top,*Bottom,*Current;

    int Length;
    int Total;
    bool IsInit;

    void ListError();
};

#endif /* CONTAIN_H */
