/*
 * wcon v0.5 GUI library for the console
 * Written by Fakhir Ansari <ansari89@yahoo.com>
 *
 * Interface to the mouse
 *
 */
#ifndef CMOUSE_H
#define CMOUSE_H

#include "data.h"

#ifdef X_UNIX
#include <gpm.h>
#endif

/* Mouse events */
#define CMOUSE_MOVE         1
#define CMOUSE_LEFT_DOWN    2
#define CMOUSE_RIGHT_DOWN   3
#define CMOUSE_RIGHT_UP     4
#define CMOUSE_LEFT_UP      5

/* The mouse class */
class CMouse {
public:
    CMouse();
    ~CMouse();

    /* Displaying and hiding the mouse */
    void Display();
    void Hide();

    int Get();
    int Event();

    /* Havent worked on this yet */
    void Pointer(int);

    int x,y;
    int b1,b2;

private:
    int EventType();

    int has_mouse;
    int Displayed;

    /* Data members to identify event */
    int old_x,old_y;
    int old_b1,old_b2;

#ifdef X_UNIX
    Gpm_Event ev;
#endif
};


#endif /* CMOUSE_H */
