/*
 * wcon v0.5 GUI library for the console
 * Written by Fakhir Ansari <ansari89@yahoo.com>
 *
 * A few basic classes
 *
 */
#ifndef XBASE_H
#define XBASE_H

#define MIN_WIDTH 1
#define MIN_HEIGHT 1

/* A point class */
class CPoint {
public:
    CPoint(int = 0,int = 0);
    
    int GetX();
    int GetY();
    
    void SetX(int);
    void SetY(int);
    void SetXY(int,int);

    void Move(int,int);

    /* Kept public before these are most frequently used */
    int x,y;
};


/* A rectangle class */
class CRect {
public:
    CRect();
    CRect(int,int,int,int);

    void GetCoords(int &,int &,int &,int &);
    void SetCoords(int,int,int,int);
    void SetCoordsNoClip(int,int,int,int);
    int GetWidth();
    int GetHeight();
 
    void SetMinWidth(int);
    void SetMinHeight(int);
    void SetClipRegion(int,int,int,int);

    void MoveD(int,int);
    void ResizeD(int,int);
 
    void Move(int,int);
    void Resize(int,int);

    int IsIn(CPoint);
    int IsIn(int,int);

    int IsIn(CRect);
    int IsIn(int,int,int,int);
    
protected:
    CPoint UpperLeft;
    int Height, Width;

    void ClipRegion(int &,int &,int &,int &);

    /* Minimum width and height of box */
    int MinWidth, MinHeight;

    /* the limits of the box */
    int c_x1,c_y1,c_x2,c_y2;
};

extern int THEME_LIGHT;
extern int THEME_NORM;
extern int THEME_DARK;


#endif /* XBASE_H */
