/*
 * wcon v0.5 GUI library for the console
 * Written by Fakhir Ansari <ansari89@yahoo.com>
 *
 * Class used for drawing lines and boxes
 *
 */
#ifndef XDRAW_H
#define XDRAW_H


#include "data.h"
#include "xbase.h"

/* The box colors */
#define BOXLIGHT    THEME_LIGHT
#define BOXNORM     THEME_NORM
#define BOXDARK     THEME_DARK

#define BOX         THEME_NORM
#define BOXUNACTIVE THEME_DARK

/* Line and text colors */
#define LINEC       THEME_DARK
#define TEXTC       THEME_NORM

/* The draw class */
class CDraw {
public:
    CDraw();
    ~CDraw();

    /* Drawing functions */
    void DrawKewlBox(CRect);
    void KewlVLine(int,int,int);
    void KewlHLine(int,int,int);

    void Rectangle(CRect,int = BOX);
    void RectangleUnactive(CRect);

    void HLine(CPoint,CPoint,int = LINEC);
    void VLine(CPoint,CPoint,int = LINEC);
    void HLine(int,int,int,int = LINEC);
    void VLine(int,int,int,int = LINEC);

    void TextCenter(CPoint,CPoint,char *,int = TEXTC);
};

extern CDraw MyDraw;

#endif /* XDRAW_H */
