/*
 * wcon v0.5 GUI library for the console
 * Written by Fakhir Ansari <ansari89@yahoo.com>
 *
 * Utility classes
 *
 */
#ifndef X_UTIL
#define X_UTIL

#include <stdio.h>

#include "data.h"
#include "xinter.h"


/* The charset to allow in the input field of the filename */
#define CFILEDIALOG_FCHAR "abcdefghijklmnopqrstuvwxyz\
ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789._/: ()'`?<>!@#$^*-+"
#define CFILEDIALOG_FMAX FILENAME_MAX

/* File flags. Identify the operation to perform by the dialog box */
/* Open a file */
#define CFILEDIALOG_FOPEN 1
/* Save a file */
#define CFILEDIALOG_FSAVE 2
/* Open a directory */
#define CFILEDIALOG_DOPEN 3


/* The file dialogbox. Inputs filename for saving or opening */
class CFileDialog : public CWindow {
public:
    CFileDialog(int,int);

    virtual bool OnPreCreate();
    virtual bool OnCommand(int Handle,long int Event,CPoint p,int Key,
                           int Status);

private:
    /* Utility functions */
    bool UpdateList();

    /* button handles */
    int Ok;
    int Cancel;
    int EBox;
    int LBox;

    int SigHandle;
    int Mode;
};


#endif /* X_UTIL */
