/*
 * Keyboard - getting keystrokes etc
 * Written by Fakhir Ansari <ansari89@yahoo.com>
 *
 * Module - The keyboard class.
 *          It gives an interface to the program of the
 *          terminal's keyboard. The application must
 *          get all key strokes through this class.
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "data.h"

#if defined(X_UNIX) || defined(X_DJGPP)
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <curses.h>
#endif


#include "keyboard.h"

CKeyboard::CKeyboard()
{
    LastKey = 0;
}

CKeyboard::~CKeyboard()
{

}

int CKeyboard::KeyPressed()
{
#if defined(X_UNIX) || defined(X_DJGPP)
    fd_set fds;
    struct timeval tv;
    int ret;

    FD_ZERO(&fds);
    FD_SET(0,&fds);
    tv.tv_sec = 0;
    tv.tv_usec = 10;

    ret = select(1,&fds,NULL,NULL,&tv);

    if (ret == -1) return 0;
    else return ret;
#else
    return kbhit();
#endif
}

int CKeyboard::Getch()
{
    return getch();
}

int CKeyboard::GetLastKey()
{
    return LastKey;
}

