/*
 * wcon v0.5 GUI library for the console
 * Written by Fakhir Ansari <ansari89@yahoo.com>
 *
 * Module - Displays the desktop images. Part of the interace
 *          library
 *
 */

#include <stdio.h>

#include "data.h"
#include "screen.h"
#include "xdesktop.h"

/* Dimensions of the images */
int XDESKTOP_MAXLINES = -1;
int XDESKTOP_SCRLINES = -1;
int XDESKTOP_SCRCOLS = -1;

CDeskTop::CDeskTop()
{
    HasDesktop = false;
    Image = NULL;
}

CDeskTop::~CDeskTop()
{
    HasDesktop = false;
    if (Image)
        delete [] Image;
}

bool CDeskTop::Display(int no)
{
    int i,index;

    if (!HasDesktop)
	return false;

    if (XDESKTOP_MAXLINES < 0) {
        XDESKTOP_MAXLINES = MAX_Y;
        XDESKTOP_SCRLINES = MAX_Y;
        XDESKTOP_SCRCOLS = MAX_X;
    }

#if defined(X_UNIX) || defined (X_DJGPP)

    index = no*(XDESKTOP_SCRLINES*no);

    for (i=0;i<XDESKTOP_SCRLINES;i++) {
	MyScreen.SetCursor(0,i);
	addchnstr(&Image[index*XDESKTOP_SCRCOLS],XDESKTOP_SCRCOLS);
	index++;
    }

#endif

    return true;
}

bool CDeskTop::LoadFile(char *str)
{
    FILE *Infile;

    if (!str)
        return false;

    if (XDESKTOP_MAXLINES < 0) {
        XDESKTOP_MAXLINES = MAX_Y;
        XDESKTOP_SCRLINES = MAX_Y;
        XDESKTOP_SCRCOLS = MAX_X;
    }

    if (!Image)
        Image = new chtype[XDESKTOP_MAXLINES*XDESKTOP_SCRCOLS];

    Infile = fopen(str,"rb");
    if (Infile == NULL)
	return false;

    fread(Image,XDESKTOP_SCRCOLS*XDESKTOP_MAXLINES*sizeof(chtype),1,Infile);
    fclose(Infile);

    HasDesktop = true;
    return true;
}
