/*
 * wcon v0.5 GUI library for the console
 * Written by Fakhir Ansari <ansari89@yahoo.com>
 *
 * Module - The label control of the interface
 *
 */

#include <stdlib.h>
#include <string.h>

#include "xinter.h"
#include "screen.h"


CLabel::CLabel()
{
    Text = NULL;
}

CLabel::CLabel(char *str)
{
    Text = NULL;
    SetLabel(str);
}

CLabel::~CLabel()
{

}

void CLabel::SetLabel(char *str)
{
    int Len;

    if (Text)
        delete [] Text;

    Len = strlen(str);
    Text = new char [Len+1];
    strcpy(Text,str);
}

char *CLabel::GetLabel()
{
    return Text;
}

bool CLabel::OnClose()
{
    if (Text)
	delete [] Text;

    Text = NULL;
}

bool CLabel::OnPaint()
{
    CRect r;
    int x1,y1,x2,y2;

    if (!Text || !(*Text))
	return false;

    r = MapToScreen(Property.Rect,this);
    r.GetCoords(x1,y1,x2,y2);

    
    MyScreen.SetColor(CLABEL_COLOR1);
    MyScreen.PutCharXY(x1,y1,Text[0]);
    
    if (strlen(Text) > 1) {
	MyScreen.SetColor(CLABEL_COLOR2);
	MyScreen.PrintXY(x1+1,y1,Text+1);
    }

    return true;
}

bool CLabel::OnGetFocus()
{
    OnPaint();

    return true;
}


bool CLabel::OnPreCreate()
{
    int x1,y1,x2,y2;
    int Len;

    Property.Style = CWIN_NOTABSTOP;
    Property.Rect.GetCoords(x1,y1,x2,y2);

    Len = strlen(Text);
    x2 = x1+Len-1;
    y2 = y1;
    Property.Rect.SetCoords(x1,y2,x2,y2);

    return true;
}
